var cacheToCss = require('../cache-to-css');
var Styletron = require('../styletron-server');

var fs = require('fs');
var path = require('path');
var test = require('tape');
var util = require('util');

var fixtures = require('test-fixtures');

var StyletronTest = (function (Styletron) {
  function StyletronTest() {
    var args = [], len = arguments.length;
    while ( len-- ) args[ len ] = arguments[ len ];

    Styletron.apply(this, args);
  }

  if ( Styletron ) StyletronTest.__proto__ = Styletron;
  StyletronTest.prototype = Object.create( Styletron && Styletron.prototype );
  StyletronTest.prototype.constructor = StyletronTest;
  StyletronTest.prototype.setCache = function setCache (cache) {
    this.cache = cache;
  };

  return StyletronTest;
}(Styletron));

test('test toCss', function (t) {
  t.equal(cacheToCss(fixtures.basic.cache), fixtures.basic.css);
  t.end();
});

test('test getCss method', function (t) {
  var instance = new StyletronTest();
  instance.setCache(fixtures.basic.cache);
  t.equal(instance.getCss(), fixtures.basic.css);
  t.end();
});

test('test getStylesheets method', function (t) {
  var instance = new StyletronTest();
  instance.setCache(fixtures.basic.cache);
  t.deepEqual(instance.getStylesheets(), [
    {
      css: '.c4:hover{display:none}.c0{color:red}.c1{color:green}'
    },
    {
      media: '(max-width: 800px)',
      css: '.c3:hover{color:green}.c2{color:green}'
    }
  ]);
  t.end();
});

test('test getStylesheetsHtml method', function (t) {
  var instance = new StyletronTest();
  instance.setCache(fixtures.basic.cache);
  t.equal(instance.getStylesheetsHtml(), '<style class="styletron">.c4:hover{display:none}.c0{color:red}.c1{color:green}</style><style class="styletron" media="(max-width: 800px)">.c3:hover{color:green}.c2{color:green}</style>');
  t.end();
});
